=== debian/changelog ===
xrootd (5.7.3-1) unstable; urgency=medium

  * Update to version 5.7.3
  * Drop patches accepted upstream
  * Build xrootd-ceph-plugins for loong64
  * Don't build libxrdec1 for 32 bit architectures

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 01 Feb 2025 09:00:18 +0100
