=== debian/changelog ===
xrootd (5.8.0-1) unstable; urgency=medium

  * Update to version 5.8.0
  * Move user/group creation logic to sysusers.d fragment
  * Set HOSTNAME to localhost during testing
  * Set _PYTHON_HOST_PLATFORM for reproducible builds

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 22 Mar 2025 10:57:27 +0100
